<?php

namespace Drupal\pagebreak\Plugin\CKEditorPlugin;

use Drupal\ckeditor\CKEditorPluginBase;
use Drupal\editor\Entity\Editor;

/**
 * Defines the "pagebreak" plugin.
 *
 * @CKEditorPlugin(
 *   id = "pagebreak",
 *   label = @Translation("PageBreak"),
 * )
 */
class PageBreak extends CKEditorPluginBase {

  /**
   * Get libraries path to plugin.
   *
   * @return string
   */
  private function getLibrariesPath() {
    $libraries_path = 'libraries/pagebreak';
    if (\Drupal::hasService('library.libraries_directory_file_finder')) {
      $libraries_path = \Drupal::service('library.libraries_directory_file_finder')
        ->find('pagebreak');
    }
    elseif (function_exists('libraries_get_path')) {
      $libraries_path = libraries_get_path('pagebreak');
    }
    return $libraries_path;
  }

  /**
   * {@inheritdoc}
   */
  public function getFile() {
    return $this->getLibrariesPath() . '/plugin.js';
  }

  /**
   * {@inheritdoc}
   */
  public function getDependencies(Editor $editor) {
    return ['fakeobjects'];
  }

  /**
   * {@inheritdoc}
   */
  public function getConfig(Editor $editor) {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function getButtons() {
    return [
      'PageBreak' => [
        'label' => $this->t('PageBreak'),
        'image' => $this->getLibrariesPath() . '/icons/pagebreak.png',
      ],
    ];
  }

}
